#include <math.h>
#include <iostream>
#include <conio.h>
#include <vector>
#include <string>
#include "svg.h"
using namespace std;

/*size_t k=0;
float
step(size_t& k, size_t bin_count, double min,double max){
    float interval;
    double bin_size= (max-min)/bin_count;
    if (k < bin_count - 1){
            interval = min + (k + 1) * bin_size;
            k+=1;
        }
    return interval;
}
void
svg_begin(double width, double height) {
    cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    cout << "<svg ";
    cout << "width='" << width << "' ";
    cout << "height='" << height << "' ";
    cout << "viewBox='0 0 " << width << " " << height << "' ";
    cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void
svg_end() {
    cout << "</svg>\n";
}
void
svg_text(double left, double baseline, string text) {
    cout << "<text x='" << left << "' y='" << baseline << "'>" << text << "</text>";
}

void svg_rect(double x, double y, double width, double height, string colour = "black", string fill = "black"){
    cout << "<rect x='"<<x<<"' y='"<<y<<"' width='"<<width<<"' height='"<<height<<"' stroke = '"<<colour <<"' fill = '"<<fill<<"' />";
}

void
show_histogram_svg(const vector<size_t>& bins, double min,double max) {
    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;
    const auto BLOCK_WIDTH = 10;
    const auto INTER_WIDTH=30;
    double top = 0;
    double max_count = bins[0];
    for (size_t i = 0; i < bins.size(); i++) {
        if (bins[i] > max_count)
            max_count = bins[i];
    }
    svg_begin(400, 300);
    for (size_t bin : bins) {
        const double bin_width = (IMAGE_WIDTH - TEXT_WIDTH)*(bin/max_count);
        svg_text(TEXT_LEFT+INTER_WIDTH, top + TEXT_BASELINE, to_string(bin));
        svg_rect(TEXT_WIDTH+INTER_WIDTH, top, bin_width, BIN_HEIGHT, "blue", "#FF00FF");
        top += BIN_HEIGHT;
        if (bin!=bins[bins.size()-1]){
            float inter=step(k,bins.size(),min,max);
            svg_text(TEXT_LEFT, top + TEXT_BASELINE, to_string(inter));
            top += BIN_HEIGHT;
        }
    }
    svg_end();
}
*/
void
svg_begin(double width, double height)
{
    cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    cout << "<svg ";
    cout << "width='" << width << "' ";
    cout << "height='" << height << "' ";
    cout << "viewBox='0 0 " << width << " " << height << "' ";
    cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void
svg_end()
{
    cout << "</svg>\n";
}

void
svg_text(double left, double baseline, string text)
{
    cout << "<text x='" << left << "' y='" << baseline << "'>" << text << "</text>";
}

void
svg_rect(double x, double y, double width, double height, string stroke = "black", string fill = "black")
{
    cout << "<rect x='"<<x<<"' y='"<<y<<"' width='"<<width<<"' height='"<<height<<"' stroke='"<<stroke<<"' fill='"<<fill<<"' />";

}


void
show_histogram_svg(const vector<size_t>& bins)
{
    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;
    const auto BLOCK_WIDTH = 10;
    const auto BLACK = "black";
    const auto RED = "red";
    const auto MAX_WIDTH = IMAGE_WIDTH-TEXT_WIDTH;


    svg_begin(IMAGE_WIDTH,IMAGE_HEIGHT);

    double top = 0;
    double max_count = bins[0];
    for (size_t i = 0; i < bins.size(); i++)
    {
        if (max_count<bins[i])
        {
            max_count=bins[i];
        }
    }

    for (size_t bin : bins)
    {
        double bin_width = (MAX_WIDTH)*(bin/max_count);
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, to_string(bin));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT, BLACK, RED);
        top += BIN_HEIGHT;
    }

    svg_end();
}
